【LeetCode】11.盛最多水的容器

博客 分享
0 278
张三
张三 2022-04-05 23:57:37
悬赏:0 积分 收藏

【LeetCode】11. 盛最多水的容器

11. 盛最多水的容器

知识点:双指针

题目描述

给定一个长度为 n 的整数数组 height 。有 n 条垂线,第 i 条线的两个端点是 (i, 0) 和 (i, height[i]) 。

找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水。

返回容器可以储存的最大水量。

说明:你不能倾斜容器。

示例

image

输入:[1,8,6,2,5,4,8,3,7]输出:49 解释:图中垂直线代表输入数组 [1,8,6,2,5,4,8,3,7]。在此情况下,容器能够容纳水(表示为蓝色部分)的最大值为 49。输入:height = [1,1]输出:1

解法一:双指针

这道题目刚一看可能想用单调栈去解,类似84题那样,把持一个单调递减栈,但是仔细一想其实不是那个意思,单调栈往往是用来寻找下一个比自己大或者比自己小的元素,但是这道题是找最后一个比自己大的元素。所以不能去单调栈的想法去解
其实可以首尾双指针,因为想要最大嘛,索性宽度直接就最大,那么对于两个指针,面积是多大呢
area = min(height[left],height[right]) * (right-left)
那这次面积求完以后该移动谁呢?想一下,应该移动两者中小的那一个,为什么?

  • if移动小的那一个,那接下来元素if比它小,那面积就更小了,if比它大,那面积就可能会增大,所以总体来说是可能会变大的;
  • if移动大的那一个,那接下来的元素if比小的那一个小,那面积就更小了,if比小的那个大,那面积还是会变小,所以总体来说肯定会变小;

综上,所以应该移动小的那一个,直到两者见面,然后求出最大面积。

class Solution:    def maxArea(self, height: List[int]) -> int:        left, right = 0, len(height)-1        max_area = 0        while left < right:            if height[left] <= height[right]:                area = height[left] * (right - left)                left += 1            else:                area = height[right] * (right-left)                right -= 1            max_area = max(max_area, area)        return max_area
posted @ 2022-04-05 22:10 Curryxin 阅读(5) 评论(0) 编辑 收藏 举报
回帖
    张三

    张三 (王者 段位)

    821 积分 (2)粉丝 (41)源码

     

    温馨提示

    亦奇源码

    最新会员